(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (factory());
}(this, (function () { 'use strict';

  module.exports = {
    // locators-string should be formatted: 0:dev_port,1:internal_access_url,2:external_access_url,3:preview_url
    locatorsParser: function (locators, isDev) {
      if (!locators) throw new Error('No locators defined');
      var parts = locators.split(',');
      return {
        internalUrl: isDev ? parts[1] + ':' + parts[0] : parts[1],
        externalUrl: isDev ? parts[2] + ':' + parts[0] : parts[2],
        previewUrl: isDev ? parts[3] + ':' + parts[0] : parts[3],
        port: parseInt(parts[0], 10),
      };
    },
    // DEPRECATED: use locatorsParser
    locatorsToUrlParser: function (locators, isDev, isExternal, isPreview) {
      if (!locators) throw new Error('No locators defined');
      var parts = locators.split(',');
      // this is where the development version of the app is running and universally accessible (locally).
      if (isDev && isExternal) return parts[2] + ':' + parts[0];
      // this is where the development version of the app is running and accessible through the
      // other parts of the development stack in the same docker-network.
      if (isDev && isPreview) return parts[3] + ':' + parts[0];
      if (isDev) return parts[1] + ':' + parts[0];
      // this is where the preview version of the app is running and universally accessible.
      if (isPreview) return parts[3];
      // this is where the real version of the app is running and universally accessible.
      return parts[2];
    },
    // DEPRECATED: use locatorsParser
    locatorsToPortParser: function (locators) {
      if (!locators) throw new Error('No locators defined');
      var parts = locators.split(',');
      return parts[0];
    },
  };

})));
